<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">





<!-- <xsl:template match="node( )[not( (self::identifier) and (parent::EVENT_RETURN) )] | @*">  --> <!-- [not(self::constr)] ?? -->
<xsl:template match="node( ) | @*"> <!-- [not(self::constr)] ?? -->
    <xsl:copy>
        <xsl:apply-templates select="@* | node( )"/>
    </xsl:copy>
</xsl:template>

<xsl:template match="message"> 
  	<message>
		<xsl:apply-templates select="@* | *"/>
  </message>
</xsl:template>

<!-- ACTION_TO_PERFORM -->
<xsl:template match="ACTION_TO_PERFORM">
	<identifier>0</identifier> 
  	<EVENT>
    	<xsl:apply-templates select="@* | node()[not(self::constr)]"/>
  	</EVENT>
</xsl:template>


<xsl:template match="act"> 
  <parameters>
      <xsl:apply-templates select="@* | node( )"/>      
  </parameters>
</xsl:template>

<xsl:variable name="perceived" select="/message/ACTION_TO_PERFORM/constr[@constraintName='perceived']"/>
<xsl:template match="id"> 
	<parameter name="id">
		<xsl:apply-templates select="@* | node( )"/>
	</parameter>
	<!-- This parameter is only added if the perceived constraint is found. -->
	<xsl:if test="($perceived='TRUE')or($perceived='FALSE')">
		<parameter name="perceived">
			<xsl:value-of select="$perceived"/>
  		</parameter> 	
	</xsl:if>
</xsl:template>

<xsl:template match="actionType"> 
  <parameter name="name">
      <xsl:apply-templates select="@* | node( )"/>
  </parameter>
</xsl:template>

<xsl:template match="actor">
	<xsl:if test="string(text())!=''">
  <parameter name="actor">
      <xsl:apply-templates select="@* | node( )"/>
  </parameter>
  </xsl:if>
</xsl:template>


<xsl:template match="actionParameters">
	<xsl:for-each select="actionParameter">
		
		<parameter>
			<xsl:attribute name="name">
				<xsl:value-of select="@parameterName" />
			</xsl:attribute>
			<xsl:value-of select="."/>		
		</parameter>
	</xsl:for-each>
</xsl:template>


<!-- FRAGMENT -->
<xsl:template match="FRAGMENT">
	<xsl:if test="@fragmentType='introduction'">
		<identifier>0</identifier>		
		<INTRODUCTION>
			<parameters>
				<parameter name="introduction"><xsl:value-of select="."/></parameter>
			</parameters>		
		</INTRODUCTION>
	</xsl:if>		
</xsl:template>


<!-- DISPLAY_INFORMATION -->
<xsl:template match="DISPLAY_INFORMATION">
	<xsl:if test="@type='characters'">		
		<identifier>0</identifier>
		<CHARACTERS>
			<parameters>
				<parameter name="characters"><xsl:value-of select="."/></parameter>
			</parameters>		
		</CHARACTERS>
	</xsl:if>
	<xsl:if test="@type='location'">		
		<identifier>0</identifier>
		<LOCATION>
			<parameters>
				<parameter name="location"><xsl:value-of select="."/></parameter>
			</parameters>		
		</LOCATION>
	</xsl:if>
	<xsl:if test="@type='historyLine'">		
		<identifier>0</identifier>
		<HISTORY_LINE>
			<parameters>
				<parameter name="content"><xsl:value-of select="."/></parameter>
			</parameters>		
		</HISTORY_LINE>
	</xsl:if>	
</xsl:template>


<!-- NO ASSOCIATION -->
<xsl:template match="NO_ASSOCIATION">
	<identifier>0</identifier>
	<NO_ASSOCIATIONS/>
</xsl:template>

<!-- NO MORE ASSOCIATIONS (temporary) -->
<xsl:template match="NO_MORE_ASSOCIATIONS">
	<identifier>0</identifier>
	<NO_MORE_ASSOCIATIONS/>
</xsl:template>


<!-- CONTEXTUAL_FILTER -->
<xsl:template match="CONTEXTUAL_FILTER">
	<xsl:if test="@type='addressee'">
		<identifier>0</identifier>		
		<ENGINE_ADDRESSEE>
			<parameters>
				<parameter name="addressee"><xsl:value-of select="."/></parameter>
			</parameters>		
		</ENGINE_ADDRESSEE>
	</xsl:if>	
</xsl:template>


<xsl:template match="ASSOCIATION">
	<identifier>0</identifier> 
  	<ASSOCIATION>
  		<parameters>
    		<xsl:apply-templates select="@* | node()"/>
    	</parameters>
  	</ASSOCIATION>
</xsl:template>

<xsl:template match="actionId"> 
  <parameter name="action_id">
      <xsl:apply-templates select="@* | node( )"/>
  </parameter>
</xsl:template>

<xsl:template match="ficDataName"> 
  <parameter name="object_name">
      <xsl:apply-templates select="@* | node( )"/>
  </parameter>
</xsl:template>

<!-- POSSIBLE_USER_ACTION_MNU -->
<xsl:template match="POSSIBLE_USER_ACTION_MNU">
	<identifier>0</identifier>		
	<ENGINE_ACTION>
		<parameters>
			<parameter name="action_id"><xsl:value-of select="act/id"/></parameter>
			<parameter name="action"><xsl:value-of select="act/description"/></parameter>
		</parameters>		
	</ENGINE_ACTION>
</xsl:template>



<!-- Suppression of the identifier tags for messages coming from the IRIS-based theatre -->
<xsl:template match="/message/identifier[(following-sibling::USER_ADDRESSEE)
									 or (following-sibling::EVENT_RETURN)
									 or (following-sibling::USER_ACTION)
									 or (following-sibling::RESTART)
									 or (following-sibling::QUIT)
									 ]">
</xsl:template>	

<!-- EVENT_RETURN -->
<xsl:template match="EVENT_RETURN">	
	<ACTION_RETURN>
		<id><xsl:value-of select="/message/EVENT_RETURN/parameters/parameter[@name='id']"/></id>
		<status><xsl:value-of select="/message/EVENT_RETURN/parameters/parameter[@name='status']"/></status>
	</ACTION_RETURN>
</xsl:template>

<!-- USER_ADDRESSEE -->
<xsl:template match="USER_ADDRESSEE">	
	<USER_ACTIVITY type="selected_character">
		<xsl:value-of select="/message/USER_ADDRESSEE/parameters/parameter[@name='addressee']"/>
	</USER_ACTIVITY>
</xsl:template>

<!-- USER_ACTION-->
<xsl:template match="USER_ACTION">	
	<USER_ACTION>
		<id>
			<xsl:value-of select="parameters/parameter[@name='action_id']"/>
		</id>
	</USER_ACTION>
</xsl:template>

<!-- RESTART-->
<xsl:template match="RESTART">	
	<PARANARRATIVE_COMMAND type="restart" />
</xsl:template>

<!-- QUIT-->
<xsl:template match="QUIT">	
	<PARANARRATIVE_COMMAND type="quit" />
</xsl:template>





</xsl:stylesheet>